// C. Herzog fuer Grundlagen der Programmierung, 1.12.2004

abstract class Set {

// Attribute:
    protected int currentSize;		// Aktuelle Mchtigkeit der Menge

// datenstrukturabhaengige, abstrakte Methoden:

    // liefert Enumeration ueber die Menge:
    public abstract Enumeration getEnumeration();

    // Einfuegen eines Elementes:
    public abstract void insert(Object o) throws MultipleElementSetException;

    // Entfernen eines Elementes:
    public abstract void delete(Object o) throws NotContainsElementSetException;

// datenstrukturunabhaengige Methoden:

    // Abfrage, ob Menge leer ist:
    public boolean isEmpty() {
	return size() == 0;
    }

    // Abfrage, ob Element enthalten ist:
    public boolean contains(Object o) {

	Enumeration enum = getEnumeration();

	while (enum.hasMoreElements()) {
	   Object item = enum.nextElement();
	   // Falls gefunden:
	   if (item.equals(o))
	      return true;
	}
	// i nicht gefunden:
	return false;
    }

    // Abfrage nach Groesse der Menge:
    public int size() {
	return currentSize;
    }

    // Abfrage nach Teilmengeneigenschaft:
    public boolean isSubset(Set s) {

	Enumeration enum = getEnumeration();

	while (enum.hasMoreElements()) {

	    if (! s.contains(enum.nextElement()))
	       return false;
	}
	// Teilmengeneigenschaft ist nie verletzt:
	return true;
    }

    // Ausgabefunktion:
    public String toString() {
	String result = "{";
	Enumeration enum = getEnumeration();
	while (enum.hasMoreElements()) {
	   result += enum.nextElement();
	   if (enum.hasMoreElements())
	      result += ",";
	}
	return result + "}";
    }
}
